unit ugamain;

{$mode objfpc}{$H+}

interface

uses
  windows, Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, Types;

type

  { TForm1 }

  TForm1 = class(TForm)
    il: TImageList;
    pb: TPaintBox;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure pbMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer
      );
  private
    fBackGround : TBitmap;
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.pbMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var bmp : TBitmap;
    mask : TBitmap;
    mw, mh : integer;
begin
  bmp := TBitmap.Create;
  mask := TBitmap.Create;
  try
    bmp.Assign(fBackGround);
    bmp.canvas.CopyMode := SRCAND;
    il.GetBitmap(1, mask);
    mw := mask.Width;
    mh := mask.Height;
    bmp.Canvas.CopyRect(Rect(x, y, x+mw, y+mh), mask.canvas, Rect(0, 0, mw, mh));
    il.GetBitmap(0, mask);
    bmp.Canvas.CopyMode := MergePaint;
    bmp.Canvas.CopyRect(Rect(x, y, x+mw, y+mh), mask.canvas, Rect(0, 0, mw, mh));
    pb.canvas.copyrect(pb.clientrect, bmp.canvas, Rect(0, 0, bmp.width, bmp.height))
  finally
   mask.Free;
    bmp.Free;
  end;
end;


procedure TForm1.FormCreate(Sender: TObject);
var r, c : integer;
   col : TColor;
begin
  fBackGround := TBitmap.Create;
  fBackground.Width := pb.ClientWidth;
  fBackground.Height := pb.ClientHeight;
  with fBackground.Canvas do
  begin
    Brush.Color := clWhite;
    Pen.Color := clBlack;
    FillRect(pb.ClientRect);
    r := 10;
    c := 10;
    while (r < pb.ClientHeight) do
    begin
      while (c < pb.ClientWidth) do
      begin
        Ellipse(c-5, r-5, c+5, r+5);
        Inc(c, 10);
      end;
      Inc(r, 10);
      c := 10;
    end;
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  fBackGround.Free;
end;

end.

